define([
	"dojo/_base/declare",
	"dojo/when",
	"dojox/mvc/getPlainValue",

	"aps/_View",
	"aps/ResourceStore",

	"./displayError"
], function (
	declare,
	when,
	getPlainValue,

	_View,
	Store,

	displayError
) {
	var subscriptionId;

	return declare(_View, {
		init: function() {
			/* Create widgets */
			return ["aps/Panel", { id: "wizard_panel" }, [
					["aps/Output", {
						id: "wizard_contents",
						content: "<h2>Let's create one more server </h2>" +
								"Before getting started, make sure you have all necessary parameters: <br>" +
								"<ul> <li> CPU power - number of CPU cores" +
								"<li> Disk space - GB" +
								"<li> RAM space - MB"
                    }]
            ]];
		},

		onContext: function() {
			subscriptionId = aps.context.vars.context.aps.subscription;
			aps.context.wizardState.forEach(function(view) {
					view.visible = true;
				}
			);
			aps.apsc.wizardState(aps.context.wizardState);
			aps.apsc.hideLoading();
		},

		onNext: function() {
			aps.apsc.next();
		},

		onSubmit: function() {
			aps.context.subscriptionId = subscriptionId;

            /* Create the data store */
			var store = new Store({
				apsType: "http://aps-standard.org/samples/sample-basic/vps/1.0",
				target: "/aps/2/resources/"
			});

			var newVPS = aps.context.wizardData["http://aps-standard.org/samples/sample-basic#vps-props"]; // Receive data from the last step
			when(store.put(newVPS),
				function() {
					  aps.apsc.gotoView("servers");
				},
				displayError
			);
		}
	});
});
